#!/bin/bash
. /etc/default/kernel-install-helpers
. /lib/gentoo/functions.sh

KERNELHOME="$(readlink "${MODLIB}/source")"

[ -z ""${KERNELHOME}"" ] && exit 0
[ -z "${MODLIB}" ] && exit 0

SIGNALGO="$(sed -n -e 's,CONFIG_MODULE_SIG_HASH="\(.*\)",\1,p' ${KERNELHOME}/.config)"

einfo "Signing kernel modules"
find "${MODLIB}" -name "*.ko*" -exec qfile {} + \
| sed -n \
	-e 's,.* (\(.*\)),\1,p' \
	-e 's,[^:]*: \(.*\),\1,p' \
| while read MODULE ; do
	eindent
	einfo "Signing ${MODULE}"
	"${KERNELHOME}"/scripts/sign-file "${SIGNALGO}" "${KERNELHOME}"/certs/signing_key.pem "${KERNELHOME}"/certs/signing_key.x509 "${MODULE}"
	eend $?
	eoutdent
done
eend $?
